import { ApiFunction } from '../../types/common';
import { ApiHttpMethod } from '../../types/http';
import { ServerRoute } from '../../types/config';
import { CreateApiParam, HooksGatewayAdapter } from './adapter';
import { IMidwayContainer, IMidwayApplication, IMidwayContext } from '@midwayjs/core';
import { ComponentConfig } from './interface';
export declare class HTTPGateway implements HooksGatewayAdapter {
    config: ComponentConfig;
    container: IMidwayContainer;
    app: IMidwayApplication<IMidwayContext>;
    constructor(config: ComponentConfig);
    is(route: ServerRoute): boolean;
    createApi(param: CreateApiParam): void;
    createApiFunction(config: {
        containerId: string;
        httpMethod: ApiHttpMethod;
        httpPath: string;
        fn: ApiFunction;
    }): {
        new (): {
            ctx: any;
            handler(): Promise<any>;
        };
    };
    onError(ctx: any, error: any): void;
    getGlobalMiddleware(): any[];
    afterCreate(): void;
    get isViteProject(): boolean;
}
