import axios from 'axios';

const defaults = {
  async request(param) {
    const enableSuperjson = param.meta && param.meta.superjson;

    try {
      var _response$headers, _response$headers$con;

      const response = await axios({
        baseURL: defaults.baseURL,
        ...param
      });

      if ((response === null || response === void 0 ? void 0 : (_response$headers = response.headers) === null || _response$headers === void 0 ? void 0 : (_response$headers$con = _response$headers['content-type']) === null || _response$headers$con === void 0 ? void 0 : _response$headers$con.indexOf('application/json')) !== -1 && enableSuperjson && response !== null && response !== void 0 && response.data) {
        const superjson = await import('superjson');
        return superjson.deserialize(response.data);
      }

      return response === null || response === void 0 ? void 0 : response.data;
    } catch (error) {
      var _e$response;

      const e = error;

      if (enableSuperjson && e !== null && e !== void 0 && (_e$response = e.response) !== null && _e$response !== void 0 && _e$response.data) {
        const superjson = await import('superjson');
        throw superjson.deserialize(e.response.data);
      }

      throw e;
    }
  },

  baseURL: ''
};
function request(param) {
  return defaults.request(param);
}

export { defaults, request };
